var NS_VOTE = {
	memoUrls : [],
	memo : [],
	
	domain : "http://www.netscape.com/",
	permalinkPage : "netscape\.com/story/[0-9]{4}/[0-9]{2}/[0-9]{2}/.*",

	lookupURL : "api/storystatus-b64/",
	voteURL : "api/remotevote-b64/",
	sinkURL : "api/remotesink-b64/",
		
	currentPermalink : "about:blank",
	
	domainBlacklist : "^https?://[^/]*((anchors|design|autos|books|humor|careers|celebrities|diy|donoevil|family|travel|gay|health|personals|men|money|movies|music|news|pets|politics|videos|realestate|religion|science|shopping|sports|tech|tv|videogames|women|www)\.netscape\.com|\.?hotmail\.com|mail\.google\.com)/",

	DEBUG : true,
	
	prefs : null,
	prefBranch : "extensions.netscape.vote.",
	
	load : function () {
		var appcontent = document.getElementById("appcontent");

		if (appcontent){
			appcontent.addEventListener("select", function (event) { NS_VOTE.loadCached(); }, false);
			appcontent.addEventListener("DOMContentLoaded", function (event) { NS_VOTE.loadCached(); }, true);
		}

		this.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(this.prefBranch);
	},
	
	loadCached : function () {
		this.updateButtons();
		
		if (this.prefs.getBoolPref("disabled") == false){
			var url = window.content.location.href;
			
			// Make sure page is not about:blank or somesuch
			if ((url.indexOf("http") != 0) && (url.indexOf("ftp") != 0)){
				return;
			}
			else {
				var re = new RegExp(this.domainBlacklist, "i");
				
				if (url.match(re)){
					var nsre = new RegExp(this.permalinkPage, "i");
					
					if (url.match(nsre)){
						// Check for story information to update the cache
						var doc = window.content.document;
						var links = doc.getElementsByTagName("link");
						
						for (var i = 0; i < links.length; i++){
							if (links[i].getAttribute("rel")){
								if (links[i].getAttribute("rel") == "bookmark"){
									if (links[i].getAttribute("title") == "Source") {
										// Grab the data, add it to cached domains.
										
										var data = {
											url : "",
											submitted : false,
											votes : 0,
											sinks : 0,
											comments : 0,
											link : "",
											voted : false
										};
										
										data.link = doc.location.href;
										data.submitted = true;
										data.url = links[i].getAttribute("href");
										
										// Find the vote and comment values.
										
										var metas = doc.getElementsByTagName("meta");
										
										for (var x = 0; x < metas.length; x++){
											if (metas[x].getAttribute("name")){
												if (metas[x].getAttribute("name") == "votes"){
													data.votes = metas[x].getAttribute("content");
												}
												else if (metas[x].getAttribute("name") == "sinks"){
													data.sinks = metas[x].getAttribute("content");
												}
												else if (metas[x].getAttribute("name") == "comments"){
													data.comments = metas[x].getAttribute("content");
												}
											}
										}
										
										// Check if data is already stored for this URL
										for (var q = 0; q < this.memoUrls.length; q++){
											if (this.memoUrls[q] == data.url){
												found = true;
												data.voted = this.memo[q].voted;
												
												if ((idx = this.getMemoIndex(data.url)) >= 0){
													this.memo[q] = data;
												}
												
												break;
											}
										}
	
										if (!found){
											this.memoUrls.push(data.url);
											this.memo.push(data);
										}
										
										return;
									}
								}
							}
						}
					}
					
					return;
				}
			}
			
			this.memoUrls.push(url);
			
			var found = false;
			
			// Check to make sure this URL hasn't been requested...
			// This is necessary for concurrent requests so that the server
			// doesn't get hammered.
			for (var i = 0; i < this.memoUrls.length; i++){
				if ((this.memoUrls[i] == url) && (i < this.memoUrls.length - 1)){
					found = true;
					
					// Check if URL details are already cached.
					if ((idx = this.getMemoIndex(url)) >= 0){
						// If so, update the button
						this.updateButtons(this.memo[idx]);
						return;
					}
						
					break;
				}
			}
			
			if (!found){
				this.onNewPageLoad(url);
			}
		}
	
		return;
	},
	
	onNewPageLoad : function (url) {
		function callaback(requester, request){
			var xml = request.responseXML;
			var cachedURL = requester.parseMainXML(xml);
			
			if (!requester.arrayContains(requester.memo, cachedURL)){
				requester.memo.push(cachedURL);
			}
			
			requester.updateButtons(cachedURL);
		}

		var req = new NS_VOTE_AJAX(this.domain + this.lookupURL + NS_BASE64.encode(url), "GET", true, this);
		req.execute(callaback);
	},
	
	parseMainXML : function (xml){
		var data = {
			url : "",
			submitted : false,
			votes : 0,
			sinks : 0,
			comments : 0,
			link : "",
			voted : false
		};
		
		data.url = xml.getElementsByTagName("story")[0].getElementsByTagName("url")[0].firstChild.nodeValue;
		data.submitted = (xml.getElementsByTagName("story")[0].getAttribute("submitted") == "true") ? true : false;
		data.voted = (xml.getElementsByTagName("story")[0].getAttribute("votedOn") == "true") ? true : false;
		
		if (data.submitted){
			data.votes = parseInt(xml.getElementsByTagName("votecount")[0].firstChild.nodeValue);
			data.sinks = parseInt(xml.getElementsByTagName("sinkcount")[0].firstChild.nodeValue);
			data.comments = parseInt(xml.getElementsByTagName("commentcount")[0].firstChild.nodeValue);
			data.link = xml.getElementsByTagName("link")[0].firstChild.nodeValue;
		}
		
		return data;
	},
	
	updateButtons : function (urlData){
		document.getElementById("netscape-vote-submit").setAttribute("disabled","true");
		document.getElementById("netscape-vote-submitted").setAttribute("disabled","true");
		document.getElementById("netscape-vote-panel").setAttribute("hidden","true");
		
		if (!this.prefs) this.load();
		
		if (this.prefs.getBoolPref("disabled") == false){			
			document.getElementById("netscape-vote-votes").setAttribute("busy","false");
			document.getElementById("netscape-vote-sinks").setAttribute("busy","false");
			document.getElementById("netscape-vote-votes").setAttribute("disabled","false");
			document.getElementById("netscape-vote-sinks").setAttribute("disabled","false");
			
			
			if (urlData){
				this.currentPermalink = urlData.link;
				
				if (urlData.submitted){
					document.getElementById("netscape-vote-metadata").setAttribute("value",urlData.votes.toString() + " votes, " + urlData.sinks.toString() + " sinks, " + urlData.comments.toString() + " comments");
					document.getElementById("netscape-vote-panel").setAttribute("hidden","false");
					
					document.getElementById("netscape-vote-submitted").setAttribute("disabled","false");
					
					if (urlData.voted){
						document.getElementById("netscape-vote-votes").setAttribute("tooltiptext","You have already voted on this page (" + urlData.votes.toString() + " votes)");
						document.getElementById("netscape-vote-sinks").setAttribute("tooltiptext","You have already voted on this page (" + urlData.sinks.toString() + " sinks)");
						
						document.getElementById("netscape-vote-votes").setAttribute("disabled","true");
						document.getElementById("netscape-vote-sinks").setAttribute("disabled","true");
					}
					else {
						document.getElementById("netscape-vote-votes").setAttribute("tooltiptext","Vote for this page ("+urlData.votes.toString() + " votes)");
						document.getElementById("netscape-vote-sinks").setAttribute("tooltiptext","Vote against this page (" + urlData.sinks.toString() + " sinks)");
						
						document.getElementById("netscape-vote-votes").setAttribute("disabled","false");
						document.getElementById("netscape-vote-sinks").setAttribute("disabled","false");
					}
					
					document.getElementById("netscape-vote-comments").setAttribute("tooltiptext","Discuss this page at Netscape.com ("+urlData.comments.toString() + " comments)");
				}
				else {
					document.getElementById("netscape-vote-metadata").setAttribute("value","");
					document.getElementById("netscape-vote-submit").setAttribute("disabled","false");
				}
			}
		}
	},
	
	vote : function (url) {
		function callaback(requester, request){
			document.getElementById("netscape-vote-votes").setAttribute("busy","false");
			
			var xml = request.responseXML;
			
			var voteRoot = xml.getElementsByTagName("vote")[0];

			if (voteRoot){
				if (voteRoot.getAttribute("loggedIn")){
					if (voteRoot.getAttribute("loggedIn") == "1"){
						// If logged in, update the vote total
						var idx = requester.getMemoIndex(url);
						
						if (idx >= 0){
							requester.memo[idx].voted = true;
							var sinkcount = voteRoot.getElementsByTagName("sinkcount")[0].firstChild.nodeValue;
							requester.memo[idx].sinks = sinkcount;
							var votecount = voteRoot.getElementsByTagName("votecount")[0].firstChild.nodeValue;
							requester.memo[idx].votes = votecount;
							requester.updateButtons(requester.memo[idx]);
						}
						
						if (voteRoot.getAttribute("counted") == "0"){
							alert("You have already voted on this story.");
						}
					}
					else {
						// If not logged in, send to the login page.
						var redir = voteRoot.getElementsByTagName("link")[0];
						window.content.document.location.href = redir.childNodes[0].nodeValue;
						
						if ((idx = requester.getMemoIndex(url)) >= 0){
							requester.memo[idx].url = '';
						}
						
						for (var p = 0; p < requester.memoUrls.length; p++){
							if (requester.memoUrls[p] == url){
								requester.memoUrls[p] = '';
							}
						}
					}
				}
			}
		}
		
		document.getElementById("netscape-vote-votes").setAttribute("busy","true");
		
		var req = new NS_VOTE_AJAX(this.domain + this.voteURL + NS_BASE64.encode(url), "GET", true, this);
		req.execute(callaback);
	},

	sink : function (url) {
		function callaback(requester, request){
			document.getElementById("netscape-vote-sinks").setAttribute("busy","false");
			
			var xml = request.responseXML;
			
			var voteRoot = xml.getElementsByTagName("vote")[0];

			if (voteRoot){
				if (voteRoot.getAttribute("loggedIn")){
					if (voteRoot.getAttribute("loggedIn") == "1"){
						// If logged in, update the vote total
						var idx = requester.getMemoIndex(url);
						
						if (idx >= 0){
							requester.memo[idx].voted = true;
							var sinkcount = voteRoot.getElementsByTagName("sinkcount")[0].firstChild.nodeValue;
							requester.memo[idx].sinks = sinkcount;
							var votecount = voteRoot.getElementsByTagName("votecount")[0].firstChild.nodeValue;
							requester.memo[idx].votes = votecount;
							requester.updateButtons(requester.memo[idx]);
						}
						
						if (voteRoot.getAttribute("counted") == "0"){
							alert("You have already voted on this story.");
						}
					}
					else {
						// If not logged in, send to the login page.
						var redir = voteRoot.getElementsByTagName("link")[0];
						window.content.document.location.href = redir.childNodes[0].nodeValue;
						
						if ((idx = requester.getMemoIndex(url)) >= 0){
							requester.memo[idx].url = '';
						}
						
						for (var p = 0; p < requester.memoUrls.length; p++){
							if (requester.memoUrls[p] == url){
								requester.memoUrls[p] = '';
							}
						}
					}
				}
			}
		}

		document.getElementById("netscape-vote-sinks").setAttribute("busy","true");
		
		var req = new NS_VOTE_AJAX(this.domain + this.sinkURL + NS_BASE64.encode(url), "GET", true, this);
		req.execute(callaback);
	},
	
	logMessage : function (message) {
		var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
		consoleService.logStringMessage("NS_VOTE: " + message);
	},
	
	arrayContains : function (arr, item){
		for (var j = 0; j < arr.length; j++) {
			if (arr[j] == item) {
				return true;
			}
		}
		
		return false;
	},
	
	submitStory : function (event) {
		var u = window.content.location;
		var t = window.content.document.title;
		var c = '';
		
		if (window.content.getSelection) {
			c = window.content.getSelection();
		} else if (window.content.document.getSelection) {
			c = window.content.document.getSelection();
		} else if (window.content.document.selection) {
			c = window.content.document.selection.createRange().text;
		}
		
		if (event.which != 3) NS_VOTE.utilities.addTab(this.domain + "submit/?U=" + encodeURIComponent(u) + '&T=' + encodeURIComponent(t) + '&C=' + encodeURIComponent(c));
	},
	
	showWhoVoted : function (event) {
		openWebPanel("Who voted for this?",this.currentPermalink+"/?whovoted=sidebar");
	},
	
	showWhoSunk : function (event) {
		openWebPanel("Who sunk this?",this.currentPermalink+"/?whosunk=sidebar");
	},
	
	getMemoIndex : function (url){
		for (var i = 0; i < this.memo.length; i++){
			if (this.memo[i].url == url){
				return i;
			}
		}
		
		return -1;
	},
	
	utilities : {	
		launchUrl : function (url, event) {
			if ((event.which == 2) || (event.which == 1 && event.ctrlKey)){
				this.addTab(url);
			}
			else if (event.which == 1){
				this.inTab(url);
			}
		},
		
		addTab : function (url) {
			var browser = window.gBrowser || window.parent.gBrowser;
			var theTab = browser.addTab(url);
			browser.selectedTab = theTab;
		},
		
		inTab : function (url) {
			window.content.document.location.href = url;
		}
	}
};

function NS_VOTE_AJAX(url, method, async, parent, args){
	if (!method) method = "GET";
	if (!async) async = true;
	if (!args) args = {};
	
	this.url = url;
	this.method = method;
	this.async = async;
	this.args = args;
	
	this.request = new XMLHttpRequest();
	this.parent = parent;
	this.request.parent = this;
	
	try {
		this.request.open(this.method, this.url, this.async);		
	} catch (e) {
		this.logMessage("Error in opening request: " + this.url);
	}
	
	return this;
}

NS_VOTE_AJAX.prototype.execute = function (callback) {
	var req = this.request;

	this.request.onreadystatechange = function (event) {
		if (req.readyState == 4){
			try {
				if (req.status == 200){
					callback(req.parent.parent, req, req.parent.args);
				}
				else {
					req.parent.logMessage("Error in vote lookup status ("+req.status+").");
				}
			} catch (e) {
				req.parent.logMessage("Error in determining Web service status for URL " + req.parent.url + ":" + e);
			}
		}
	};
	
	try {
		this.request.send(null);
	} catch (e) {
		this.logMessage("Error in opening request: " + this.url);
	}
};

NS_VOTE_AJAX.prototype.logMessage = function (message) {
	var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	consoleService.logStringMessage(message);
};

window.addEventListener("load", function (event) { NS_VOTE.load(); }, false);